definition module dialogAccess;

//	Version 0.8 to 1.0

//
//	Access rules on the dialog device.
//

import	mac_types;
import	dialogDef, ioState;

RetrieveEditTexts :: !(!DialogRep s (IOState s), !Toolbox) -> (!DialogRep s (IOState s), !Toolbox);

IOStateGetDialogs			:: !(IOState s) -> (!DialogHandles s, !IOState s);
IOStateSetDialogs			:: !(DialogHandles s) !(IOState s) -> IOState s;

IOStateGetActiveDialogInfo	::				!(IOState s) -> (!Bool, !DialogInfo, !IOState s);
IOStateGetDialogInfo		:: !DialogId	!(IOState s) -> (!Bool, !DialogInfo, !IOState s);
IOStateGetDialog	:: !DialogId	!(IOState s)	-> (!Bool, !DialogRep s (IOState s), !IOState s);
IOStateGetDialogPtr	:: !DialogPtr	!(IOState s)	-> (!Bool, !DialogRep s (IOState s), !IOState s);
GetDialog			:: !DialogId !(DialogHandles s)	-> (!Bool, !DialogRep s (IOState s));

IOStateRemoveActiveDialog	::				!(IOState s) -> (!Bool, !DialogRep s (IOState s), !IOState s);
IOStateRemoveActiveDialogPtr:: !DialogPtr	!(IOState s) -> (!Bool, !DialogRep s (IOState s), !IOState s);
IOStateRemoveDialog			:: !DialogId	!(IOState s) -> (!Bool, !DialogRep s (IOState s), !IOState s);
IOStateRemoveDialogPtr		:: !DialogPtr	!(IOState s) -> (!Bool, !DialogRep s (IOState s), !IOState s);
RemoveDialogPtr				:: !DialogPtr !(DialogHandles s) -> (!Bool, !DialogRep s (IOState s), !DialogHandles s);

IOStateAddDialog			:: !(DialogRep s (IOState s))			!(IOState s) -> IOState s;
IOStateAddInactiveDialog	:: !(DialogRep s (IOState s))			!(IOState s) -> IOState s;
IOStateReplaceDialog		:: !DialogId !(DialogRep s (IOState s))	!(IOState s) -> IOState s;
IOStateSetDialogInFront		:: !DialogId							!(IOState s) -> (!Bool, !IOState s);
SetDialogInFront			:: !DialogId !(DialogHandles s) -> (!Bool, !DialogHandles s);

IOStateModalDialogActive	:: !(IOState s)					-> (!Bool,!DialogPtr,!IOState s);
IsModalDialog				:: !(DialogRep s (IOState s))	-> (!Bool,!DialogPtr);
