definition module windowAccess;


//	Version 0.8 to 1.0


import	ioState;


::	DrawMode :== Int;


DrawNoControls		:== 0;
HasControls			:== 1;
HasNoControls		:== 2;

ScrollBarWidth		:== 15;
TitleBarWidth		:== 20;
MenuBarWidth		:== 20;
WindowScreenBorder	:== 4;


WindowSystemState_WindowHandles	:: !(DeviceSystemState s) -> WindowHandles	s;

Window_size			:: !WindowPtr			!Toolbox	-> (!Point, !Toolbox);
WindowGetFrameSize	:: !(WindowHandle s)	!Toolbox	-> (!Point, !Toolbox);
UpdateDrawMode		:: !(WindowDef s (IOState s))		-> DrawMode;
WindowDefGetDrawMode:: !(WindowDef s (IOState s))		-> DrawMode;

WindowGetPtr		:: !Window							-> WindowPtr;
WindowHandleGetPtr	:: !(WindowHandle s)				-> WindowPtr;
DummyWindowHandle	:: WindowPtr						-> WindowHandle s;

ChangeAllWindowPtrs	:: !(WindowPtr -> Toolbox -> Toolbox) !(IOState s) -> IOState s;
ChangeWindowPtrs	:: !(WindowPtr -> Toolbox -> Toolbox) ![WindowHandle s] !Toolbox -> Toolbox;
CloseWindow			:: !(IOState s)	-> IOState s;
