definition module dialogInternal;

//	Version 0.8 to 1.0


import	dialogDef, ioState;
from	Picture	import Rectangle, DrawFunction;


PopUpMenuID			:== 235;

::	Response *s		=	Final		(ButtonFunction s (IOState s))
					|	RadioBox	(DialogFunction s (IOState s))
					|	Void_new;

OpenAnyDialog		:: !DialogMode !DialogPtr !(DialogDef s (IOState s)) !Toolbox
					->	(!DialogRep s (IOState s), !Toolbox);
DoNotice			:: !NoticeDef !(IOState s) -> (!NoticeButtonId, !IOState s);
DeactivateDialog	:: !(DialogRep s (IOState s)) !(IOState s) -> IOState s;

HandleDialogEvent	:: !(DialogHandle s (IOState s)) !DialogPtr !Toolbox !Int
					-> (!DialogRep s (IOState s), !Response s, !Toolbox);

DrawDefButtonOutline:: !ItemPos								!DialogPtr !Toolbox -> Toolbox;
RedrawPopUp			:: !ItemPos !SelectState !String		!DialogPtr !Toolbox -> Toolbox;
RedrawPopUpItemText	:: !ItemPos				 !String		!DialogPtr !Toolbox -> Toolbox;
DrawPopUpAbility	:: !ItemPos !SelectState				!DialogPtr !Toolbox -> Toolbox;
DrawIconOrControl	:: !ItemPos !Rectangle ![DrawFunction]	!DialogPtr !Toolbox -> Toolbox;
RedrawIconOrControl	:: !ItemPos !Rectangle ![DrawFunction]	!DialogPtr !Toolbox -> Toolbox;

GetDialogDefId		:: !(DialogDef s io) -> DialogId;
GetPopUpHandle		:: !DialogItemId ![PopUpHandle] -> PopUpHandle;

ActivateDialog		:: !(DialogHandles s) !Toolbox -> Toolbox;

Hilite				:: !DialogPtr !Int !Toolbox -> Toolbox;
Unhilite			:: !DialogPtr !Int !Toolbox -> Toolbox;
