definition module font;

//	Version 0.8 to 1.0

::	Font;

::	FontNum		:== Int;
::	FontName	:== {#Char};
::	FontStyle	:== {#Char};
::	FontSize	:== Int;
::	FontInfo	:== (!Int, !Int, !Int, !Int);

MinFontSize		:== 6;
MaxFontSize		:== 128;

FontAtts		:: !Font -> (!FontNum, !FontName, ![FontStyle], !FontSize);
StyleToStyleID	:: ![FontStyle] -> Int;

SelectFont		:: !FontName  ![FontStyle] !FontSize -> (!Bool, !Font);
DefaultFont		:: (!FontName,![FontStyle],!FontSize);
FontNames		::							[FontName];
FontStyles		:: !FontName			->	[FontStyle];
FontSizes		:: !FontName			->	[FontSize];
FontCharWidth	:: !Char		!Font	->	Int;
FontCharWidths	:: ![Char]		!Font	->	[Int];
FontStringWidth	:: !{#Char}		!Font	->	Int;
FontStringWidths:: ![{#Char}]	!Font	->	[Int];
FontMetrics		::				!Font	->	FontInfo;
