definition module menuInternal;


import	menus;
import	ioState;


AppleMenuId				:== 128;
InsertPullDownPosition	:== 0;
InsertSubPosition		:== -1;	
SystemAble				:== True;
SystemUnable			:== False;


//	Initialization and Allocation:

AppleMenu				::										!Toolbox -> (!MenuHandle s, !Toolbox);
EmptyMenuHandle			::								!MenuId !Toolbox -> (!MenuHandle s, !Toolbox);
NewMenuHandle			:: !(MenuDef	 s (IOState s)) !MenuId !Toolbox -> (!MenuHandle s, !Toolbox);
NewMenuElementHandle	:: !(MenuElement s (IOState s)) !MenuId !Toolbox -> (!MenuHandle s, !Toolbox);
DisposeMenuSystemState	:: !(DeviceSystemState s)				!Toolbox -> Toolbox;

//	Forming the MenuBar:

Insert_menu				:: !(MenuHandle s)			!Toolbox -> Toolbox;
GetMenuSystem			:: !(DeviceSystemState s)	!Toolbox -> (!DeviceSystemState s, !Toolbox);
SetMenuSystem			:: !(DeviceSystemState s)	!Toolbox -> Toolbox;

//	Access-rules on MenuSystemStates:

MenuSystemState_MenuFunction	:: !MenuId !Int !(DeviceSystemState s)
								-> (!Bool, !MenuFunction s (IOState s));
SplitMenuHandle					:: !(MenuHandle s) !Int -> (![MenuHandle s], !MenuHandle s);

//	CheckItemTitle checks for empty titles and for titles that begin with a '-'

CheckItemTitle					:: !String -> String;
